#include "fifo_queue.h"

void initQueue(char *head, char *tail)
{
    *head = 0;
    *tail = 0;
}

char queueIsEmpty(char head, char tail)
{
    if(tail == head)
    {
        return 1;
    }
    else
    {
        return 0;
    }
}

char queueIsFull(char head, char tail)
{
    if((tail == head+1) || ((tail == 0) && (head == QUEUE_DIMENSION - 1)))
    {
        return 1;
    }
    else
    {
        return 0;
    }
}

void addToQueue(char value, char *head, char *queue)
{
    queue[*head] = value;

    if((*head) == QUEUE_DIMENSION - 1)
    {
        *head = 0;
    }
    else
    {
        *head = *head + 1;
    }
}

char getFromQueue(char *tail, char *queue)
{
    char value;
    value = queue[*tail];

    if((*tail) == QUEUE_DIMENSION - 1)
    {
        *tail = 0;
    }
    else
    {
        *tail = *tail + 1;
    }

    return value;
}
